import React from "react";
import { ReactTreeListItemType } from "./types/ItemTypes";
export interface ItemOptions {
    /**
     * Color of the focused item outline & on the drop area outline
     */
    focusedOutlineColor?: string;
    /**
     * Width of the focused item outline & of the drop area outline
     */
    focusedOutlineWidth?: number;
    /**
     * Border radius of the focused item
     */
    focusedBorderRadius?: number;
    /**
     * Background color of the focused item
     */
    focusedBackgroundColor?: string;
}
export interface ReactTreeListItemProps {
    draggable?: boolean;
    item: ReactTreeListItemType;
    selectedId: string;
    indent: number;
    allowDropBefore?: boolean;
    onSelected?(item: ReactTreeListItemType): void;
    onFocusEnter?(item: ReactTreeListItemType): void;
    onArrowClick?(item: ReactTreeListItemType): void;
    onDragging?(dragging: boolean): void;
    onDropInside?(id: string, toId: string): void;
    onDropBefore?(id: string, toId: string): void;
    onDropAfter?(id: string, toId: string): void;
    options: ItemOptions;
}
export declare const ReactTreeListItem: React.FC<ReactTreeListItemProps>;
