"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactTreeListItem = void 0;
var polished_1 = require("polished");
var react_1 = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var DEFAULT_COLOR = (0, polished_1.rgba)(0, 0, 255, 1);
var ReactTreeListItem = function (_a) {
    var onDragging = _a.onDragging, onDropInside = _a.onDropInside, onDropBefore = _a.onDropBefore, onDropAfter = _a.onDropAfter, allowDropBefore = _a.allowDropBefore, props = __rest(_a, ["onDragging", "onDropInside", "onDropBefore", "onDropAfter", "allowDropBefore"]);
    var item = props.item, draggable = props.draggable;
    var label = item.label;
    var RootRef = (0, react_1.useRef)(null);
    var DropAreaRef = (0, react_1.useRef)(null);
    var BeforeDropAreaRef = (0, react_1.useRef)(null);
    var AfterDropAreaRef = (0, react_1.useRef)(null);
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    var _c = (0, react_1.useState)(false), isDragged = _c[0], setIsDragged = _c[1];
    var setDragOver = function (dragOver) {
        var _a, _b, _c;
        if (dragOver) {
            (_a = RootRef.current) === null || _a === void 0 ? void 0 : _a.classList.add("dragOver");
        }
        else if ((_b = RootRef.current) === null || _b === void 0 ? void 0 : _b.classList.contains("dragOver")) {
            (_c = RootRef.current) === null || _c === void 0 ? void 0 : _c.classList.remove("dragOver");
        }
    };
    var setBeforeDropAreaDragOver = function (dragOver) {
        var _a, _b, _c;
        if (dragOver) {
            (_a = BeforeDropAreaRef.current) === null || _a === void 0 ? void 0 : _a.classList.add("dragOver");
        }
        else if ((_b = BeforeDropAreaRef.current) === null || _b === void 0 ? void 0 : _b.classList.contains("dragOver")) {
            (_c = BeforeDropAreaRef.current) === null || _c === void 0 ? void 0 : _c.classList.remove("dragOver");
        }
    };
    var setAfterDropAreaDragOver = function (dragOver) {
        var _a, _b, _c;
        if (dragOver) {
            (_a = AfterDropAreaRef.current) === null || _a === void 0 ? void 0 : _a.classList.add("dragOver");
        }
        else if ((_b = AfterDropAreaRef.current) === null || _b === void 0 ? void 0 : _b.classList.contains("dragOver")) {
            (_c = AfterDropAreaRef.current) === null || _c === void 0 ? void 0 : _c.classList.remove("dragOver");
        }
    };
    var onDrag = function () {
        // setIsDragged(true);
    };
    var onDragStart = function (event) {
        onDragging && onDragging(true);
        if (item.id) {
            event.dataTransfer.setData("itemId", item.id);
        }
    };
    var onDragEnd = function () {
        onDragging && onDragging(false);
    };
    var onFocusKeyPress = function (event) {
        if (event.which === 13) {
            onArrowClick();
        }
    };
    var onArrowClick = function () { return props.onArrowClick && props.onArrowClick(item); };
    var onSelected = function () { return props.onSelected && props.onSelected(item); };
    (0, react_1.useEffect)(function () {
        var dragStartHandler = function () {
            setDragging(true);
        };
        var dragEndHandler = function () {
            setDragging(false);
            setIsDragged(false);
        };
        document.addEventListener("dragstart", dragStartHandler);
        document.addEventListener("dragend", dragEndHandler);
        return function () {
            document.removeEventListener("dragstart", dragStartHandler);
            document.removeEventListener("dragend", dragEndHandler);
        };
    }, []);
    var dropArea = {
        onDrop: function (event) {
            if (event.dataTransfer.getData("itemId") !== item.id &&
                onDropInside &&
                item.id) {
                onDropInside(event.dataTransfer.getData("itemId"), item.id);
            }
            setDragOver(false);
        },
        onDragOver: function (event) { return event.preventDefault(); },
        onDragEnter: function () { return setDragOver(true); },
        onDragLeave: function () { return setDragOver(false); },
    };
    var beforeDropArea = {
        onDrop: function (event) {
            if (event.dataTransfer.getData("itemId") !== item.id &&
                onDropBefore &&
                item.id) {
                onDropBefore(event.dataTransfer.getData("itemId"), item.id);
            }
            setBeforeDropAreaDragOver(false);
        },
        onDragOver: function (event) { return event.preventDefault(); },
        onDragEnter: function () { return setBeforeDropAreaDragOver(true); },
        onDragLeave: function () { return setBeforeDropAreaDragOver(false); },
    };
    var afterDropArea = {
        onDrop: function (event) {
            if (item.children &&
                item.children.length &&
                item.open &&
                onDropInside &&
                item.id) {
                onDropInside(event.dataTransfer.getData("itemId"), item.id);
            }
            else if (event.dataTransfer.getData("itemId") !== item.id &&
                onDropAfter &&
                item.id) {
                onDropAfter(event.dataTransfer.getData("itemId"), item.id);
            }
            setAfterDropAreaDragOver(false);
        },
        onDragOver: function (event) { return event.preventDefault(); },
        onDragEnter: function () { return setAfterDropAreaDragOver(true); },
        onDragLeave: function () { return setAfterDropAreaDragOver(false); },
    };
    var onClick = function (event) {
        onSelected();
    };
    return (react_1.default.createElement(Root, __assign({ ref: RootRef }, props, { 
        // Custom properties
        dragging: dragging, isDragged: isDragged, onDrag: onDrag, onDragStart: onDragStart, onDragEnd: onDragEnd, onKeyPress: onFocusKeyPress }),
        item.arrow && (react_1.default.createElement(Arrow, { onClick: function (event) {
                onArrowClick();
            } }, item.arrow)),
        react_1.default.createElement(Content, { onClick: onClick },
            item.icon && react_1.default.createElement(Icon, null, item.icon),
            react_1.default.createElement(Label, null, label)),
        allowDropBefore && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(BeforeDropArea, __assign({ ref: BeforeDropAreaRef }, beforeDropArea)),
            react_1.default.createElement(BeforeDropAreaHighlight, null))),
        react_1.default.createElement(DropArea, __assign({ ref: DropAreaRef }, dropArea)),
        react_1.default.createElement(AfterDropArea, __assign({ ref: AfterDropAreaRef }, afterDropArea)),
        react_1.default.createElement(AfterDropAreaHighlight, null)));
};
exports.ReactTreeListItem = ReactTreeListItem;
var RootComponent = react_1.default.forwardRef(function (_a, ref) {
    var draggable = _a.draggable, indent = _a.indent, selectedId = _a.selectedId, item = _a.item, onFocusEnter = _a.onFocusEnter, onSelected = _a.onSelected, onArrowClick = _a.onArrowClick, dragging = _a.dragging, isDragged = _a.isDragged, props = __rest(_a, ["draggable", "indent", "selectedId", "item", "onFocusEnter", "onSelected", "onArrowClick", "dragging", "isDragged"]);
    return react_1.default.createElement("div", __assign({ ref: ref, draggable: draggable, tabIndex: 0 }, props));
});
var Content = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject([""], [""])));
var Arrow = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject([""], [""])));
var Icon = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject([""], [""])));
var Label = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject([""], [""])));
var DropArea = styled_components_1.default.div(templateObject_5 || (templateObject_5 = __makeTemplateObject([""], [""])));
var BeforeDropArea = styled_components_1.default.div(templateObject_6 || (templateObject_6 = __makeTemplateObject([""], [""])));
var BeforeDropAreaHighlight = styled_components_1.default.div(templateObject_7 || (templateObject_7 = __makeTemplateObject([""], [""])));
var AfterDropArea = styled_components_1.default.div(templateObject_8 || (templateObject_8 = __makeTemplateObject([""], [""])));
var AfterDropAreaHighlight = styled_components_1.default.div(templateObject_9 || (templateObject_9 = __makeTemplateObject([""], [""])));
var Root = (0, styled_components_1.default)(RootComponent)(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  cursor: default;\n  position: relative;\n  display: grid;\n  grid-template-columns: auto 1fr;\n  grid-column-gap: 8px;\n  padding-left: ", "px;\n  align-items: center;\n  border-radius: ", "px;\n  transition: background 100ms;\n  background-color: ", ";\n\n  opacity: ", ";\n\n  &.dragOver {\n    box-shadow: inset 0 0 0\n      ", "px\n      ", ";\n  }\n\n  ", ", ", " *,\n  ", ", ", " *,\n  ", ", ", " * {\n    pointer-events: ", ";\n  }\n\n  ", " {\n    display: grid;\n    grid-template-columns: auto 1fr;\n    grid-column-gap: 8px;\n    padding: 4px 0;\n  }\n  ", " {\n    display: flex;\n    transition: 100ms;\n    visibility: ", ";\n    transform: rotate(", "deg);\n  }\n\n  ", " {\n    display: flex;\n    transition: 100ms;\n  }\n\n  ", " {\n    display: ", ";\n    position: absolute;\n    top: 15%;\n    left: 0;\n    width: 100%;\n    height: 70%;\n    z-index: 10;\n  }\n\n  ", ", ", " {\n    display: ", ";\n    position: absolute;\n    height: 30%;\n    width: 100%;\n    z-index: 11;\n  }\n  ", " {\n    top: 0;\n    transform: translateY(-50%);\n\n    &.dragOver + ", " {\n      display: block;\n    }\n  }\n  ", " {\n    bottom: 0;\n    transform: translateY(50%);\n\n    &.dragOver + ", " {\n      display: block;\n    }\n  }\n\n  ", " ,", " {\n    display: none;\n    position: absolute;\n    z-index: 9;\n    height: ", "px;\n    background: ", ";\n    width: calc(\n      100% -\n        ", "px\n    );\n    margin-left: ", "px;\n  }\n  ", " {\n    top: -1px;\n  }\n  ", " {\n    bottom: -1px;\n  }\n"], ["\n  cursor: default;\n  position: relative;\n  display: grid;\n  grid-template-columns: auto 1fr;\n  grid-column-gap: 8px;\n  padding-left: ", "px;\n  align-items: center;\n  border-radius: ", "px;\n  transition: background 100ms;\n  background-color: ", ";\n\n  opacity: ", ";\n\n  &.dragOver {\n    box-shadow: inset 0 0 0\n      ", "px\n      ", ";\n  }\n\n  ", ", ", " *,\n  ", ", ", " *,\n  ", ", ", " * {\n    pointer-events: ", ";\n  }\n\n  ", " {\n    display: grid;\n    grid-template-columns: auto 1fr;\n    grid-column-gap: 8px;\n    padding: 4px 0;\n  }\n  ", " {\n    display: flex;\n    transition: 100ms;\n    visibility: ", ";\n    transform: rotate(", "deg);\n  }\n\n  ", " {\n    display: flex;\n    transition: 100ms;\n  }\n\n  ", " {\n    display: ", ";\n    position: absolute;\n    top: 15%;\n    left: 0;\n    width: 100%;\n    height: 70%;\n    z-index: 10;\n  }\n\n  ", ", ", " {\n    display: ", ";\n    position: absolute;\n    height: 30%;\n    width: 100%;\n    z-index: 11;\n  }\n  ", " {\n    top: 0;\n    transform: translateY(-50%);\n\n    &.dragOver + ", " {\n      display: block;\n    }\n  }\n  ", " {\n    bottom: 0;\n    transform: translateY(50%);\n\n    &.dragOver + ", " {\n      display: block;\n    }\n  }\n\n  ", " ,", " {\n    display: none;\n    position: absolute;\n    z-index: 9;\n    height: ", "px;\n    background: ", ";\n    width: calc(\n      100% -\n        ", "px\n    );\n    margin-left: ", "px;\n  }\n  ", " {\n    top: -1px;\n  }\n  ", " {\n    bottom: -1px;\n  }\n"])), function (_a) {
    var indent = _a.indent;
    return indent * 24 + 12;
}, function (_a) {
    var _b;
    var options = _a.options;
    return (_b = options.focusedBorderRadius) !== null && _b !== void 0 ? _b : 4;
}, function (_a) {
    var _b;
    var item = _a.item, selectedId = _a.selectedId, options = _a.options;
    return item.selected || selectedId === item.id
        ? (_b = options.focusedBackgroundColor) !== null && _b !== void 0 ? _b : (0, polished_1.rgba)(DEFAULT_COLOR, 0.075)
        : "transparent";
}, function (_a) {
    var isDragged = _a.isDragged;
    return (isDragged ? 0.5 : 1);
}, function (_a) {
    var _b;
    var options = _a.options;
    return (_b = options.focusedOutlineWidth) !== null && _b !== void 0 ? _b : 2;
}, function (_a) {
    var _b;
    var options = _a.options;
    return (_b = options.focusedOutlineColor) !== null && _b !== void 0 ? _b : DEFAULT_COLOR;
}, Arrow, Arrow, Icon, Icon, Label, Label, function (_a) {
    var dragging = _a.dragging;
    return (dragging ? "none" : "");
}, Content, Arrow, function (_a) {
    var item = _a.item;
    return item.children && item.children.length ? "visible" : "hidden";
}, function (_a) {
    var item = _a.item;
    return (item.open ? 90 : 0);
}, Icon, DropArea, function (_a) {
    var dragging = _a.dragging;
    return (dragging ? "block" : "none");
}, BeforeDropArea, AfterDropArea, function (_a) {
    var dragging = _a.dragging;
    return (dragging ? "block" : "none");
}, BeforeDropArea, BeforeDropAreaHighlight, AfterDropArea, AfterDropAreaHighlight, BeforeDropAreaHighlight, AfterDropAreaHighlight, function (_a) {
    var _b;
    var options = _a.options;
    return (_b = options.focusedOutlineWidth) !== null && _b !== void 0 ? _b : 2;
}, function (_a) {
    var _b;
    var options = _a.options;
    return (_b = options.focusedOutlineColor) !== null && _b !== void 0 ? _b : DEFAULT_COLOR;
}, function (_a) {
    var indent = _a.indent, item = _a.item;
    return (indent +
        (item.open && item.children && item.children.length ? 1 : 0)) *
        24 +
        12;
}, function (_a) {
    var indent = _a.indent, item = _a.item;
    return (indent + (item.open && item.children && item.children.length ? 1 : 0)) *
        24 +
        12;
}, BeforeDropAreaHighlight, AfterDropAreaHighlight);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10;
//# sourceMappingURL=ReactTreeListItem.js.map