"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useUpdateSelectedItemById = void 0;
var lodash_1 = require("lodash");
var useUpdateSelectedItemById = function (data, callback) {
    return function (updateId) {
        if (!updateId) {
            return;
        }
        var recursiveUpdateId = function (item, index, array) {
            if (item.id === updateId) {
                array[index] = __assign(__assign({}, item), { selected: true });
            }
            else {
                array[index] = __assign(__assign({}, item), { selected: false });
            }
            if (item.children) {
                item.children.forEach(recursiveUpdateId);
            }
        };
        data.forEach(recursiveUpdateId);
        callback((0, lodash_1.cloneDeep)(data));
        return data;
    };
};
exports.useUpdateSelectedItemById = useUpdateSelectedItemById;
//# sourceMappingURL=useUpdateSelectedItemById.js.map